<script setup lang="ts">
  import { Sort } from '@shopware-pwa/types';

  const emits = defineEmits(['submit']);

  const props = defineProps<{
    controller: ReturnType<typeof useModal>;
    options: Sort[];
    value: string;
  }>();

  const currentSelectionKey = ref(props.value);

  const defaultValue = computed(() => props.value);

  syncRefs(defaultValue, currentSelectionKey);

  const onSubmit = () => {
    emits('submit', currentSelectionKey.value);
    props.controller.close();
  };

  const onCloseModal = () => {
    props.controller.close();
  };
</script>

<template>
  <SwModal backdrop-display="static" :controller="controller">
    <template #body>
      <div class="flex flex-col space-y-6">
        <div>
          <span class="text-lg/[1.625rem] font-bold">{{
            $t('product.editProductSortModal.headline')
          }}</span>
          <p class="text-(sm/6 information) pt-2">
            {{ $t('product.editProductSortModal.sublime') }}
          </p>
        </div>
        <SwSelect
          v-model="currentSelectionKey"
          key-field="key"
          label-field="label"
          :options="options"
          size="large"
        />
      </div>
    </template>
    <template #footer>
      <SwButton size="large" variant="action" @click="onCloseModal">
        {{ $t('cancel') }}
      </SwButton>
      <SwButton size="large" @click="onSubmit">{{ $t('apply') }}</SwButton>
    </template>
  </SwModal>
</template>
